import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { request } from '@/plugins/http-fetch';
import { parseObjLineToHump } from '@/utils/parse-utils';

/**
 * 查询信令列表
 * @param query 查询参数
 * @returns object
 */
export async function listTraceData(query: Record<string, any>) {
  let totalSQL = 'select count(*) as total from trace_data where 1=1 ';
  let rowsSQL = 'select * from trace_data where 1=1 ';

  // 查询
  let querySQL = '';
  if (query.imsi) {
    querySQL += ` and imsi like '%${query.imsi}%' `;
  }
  if (query.msisdn) {
    querySQL += ` and msisdn like '%${query.msisdn}%' `;
  }

  // 分页
  const pageNum = (query.pageNum - 1) * query.pageSize;
  const limtSql = ` limit ${pageNum},${query.pageSize} `;

  // 发起请求
  const result = await request({
    url: `/api/rest/databaseManagement/v1/omc_db/trace_data`,
    method: 'get',
    params: {
      totalSQL: totalSQL + querySQL,
      rowsSQL: rowsSQL + querySQL + limtSql,
    },
  });

  // 解析数据
  if (result.code === RESULT_CODE_SUCCESS) {
    const data: DataList = {
      total: 0,
      rows: [],
      code: result.code,
      msg: result.msg,
    };
    result.data.data.forEach((item: any) => {
      const itemData = item['trace_data'];
      if (Array.isArray(itemData)) {
        if (itemData.length === 1 && itemData[0]['total'] >= 0) {
          data.total = itemData[0]['total'];
        } else {
          data.rows = itemData.map(v => parseObjLineToHump(v));
        }
      }
    });
    return data;
  }
  return result;
}

/**
 * 信令数据解析HTML
 * @param id 任务ID
 * @returns
 */
export function getTraceRawInfo(id: Record<string, string>) {
  return request({
    url: `/api/rest/traceManagement/v1/decMessage/${id}`,
    method: 'get',
    responseType: 'text',
  });
}
